/* A YACC parser generated from "parser.y" */

# line 14
#ifndef lint
#define lint
#endif
#define defTycon(n,l,lhs,rhs,w)  tyconDefn(intOf(l),lhs,rhs,w); sp-=n
#define sigdecl(l,vs,t)          ap(SIGDECL,triple(l,vs,t))
#define grded(gs)                ap(GUARDED,gs)
#define bang(t)                  ap(BANG,t)
#define only(t)                  ap(ONLY,t)
#define letrec(bs,e)             (nonNull(bs) ? ap(LETREC,pair(bs,e)) : e)
#define yyerror(s)               /* errors handled elsewhere */
#define YYSTYPE                  Cell

static Cell   local gcShadow     Args((Int,Cell));
static Void   local syntaxError  Args((String));
static String local unexpected   Args((Void));
static Cell   local checkPrec    Args((Cell));
static Void   local fixDefn      Args((Syntax,Cell,Cell,List));
static Void   local setSyntax    Args((Int,Syntax,Cell));
static Cell   local buildTuple   Args((List));
static List   local checkContext Args((List));
static Cell   local checkClass   Args((Cell));
static Cell   local checkInst    Args((Cell));
static Pair   local checkDo      Args((List));
static Cell   local checkTyLhs   Args((Cell));
static Cell   local tidyInfix    Args((Cell));

/* For the purposes of reasonably portable garbage collection, it is
 * necessary to simulate the YACC stack on the Hugs stack to keep
 * track of all intermediate constructs.  The lexical analyser
 * pushes a token onto the stack for each token that is found, with
 * these elements being removed as reduce actions are performed,
 * taking account of look-ahead tokens as described by gcShadow()
 * below.
 *
 * Of the non-terminals used below, only start, topDecl, fixDecl & begin
 * do not leave any values on the Hugs stack.  The same is true for the
 * terminals EXPR and SCRIPT.  At the end of a successful parse, there
 * should only be one element left on the stack, containing the result
 * of the parse.
 */

#define gc0(e)                   gcShadow(0,e)
#define gc1(e)                   gcShadow(1,e)
#define gc2(e)                   gcShadow(2,e)
#define gc3(e)                   gcShadow(3,e)
#define gc4(e)                   gcShadow(4,e)
#define gc5(e)                   gcShadow(5,e)
#define gc6(e)                   gcShadow(6,e)
#define gc7(e)                   gcShadow(7,e)

#define EXPR 257
#define SCRIPT 258
#define CASEXP 259
#define OF 260
#define DATA 261
#define TYPE 262
#define IF 263
#define THEN 264
#define ELSE 265
#define WHERE 266
#define LET 267
#define IN 268
#define INFIX 269
#define INFIXL 270
#define INFIXR 271
#define PRIMITIVE 272
#define TNEWTYPE 273
#define DEFAULT 274
#define DERIVING 275
#define DO 276
#define TCLASS 277
#define TINSTANCE 278
#define TRUNST 279
#define REPEAT 280
#define VAROP 281
#define VARID 282
#define NUMLIT 283
#define CHARLIT 284
#define STRINGLIT 285
#define CONOP 286
#define CONID 287
#define RECSELID 288
#define COCO 289
#define UPTO 290
#define FROM 291
#define ARROW 292
#define IMPLIES 293
#define MODULE 294
#define IMPORT 295
#define HIDING 296
#define QUALIFIED 297
#define ASMOD 298
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern short yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#ifndef YYSTYPE
#define YYSTYPE int
#endif
YYSTYPE yylval, yyval;
# define YYERRCODE 256

#line 602


static Cell local gcShadow(n,e)         /* keep parsed fragments on stack  */
Int  n;
Cell e; {
    /* If a look ahead token is held then the required stack transformation
     * is:
     *   pushed: n               1     0          1     0
     *           x1  |  ...  |  xn  |  la   ===>  e  |  la
     *                                top()            top()
     *
     * Othwerwise, the transformation is:
     *   pushed: n-1             0        0
     *           x1  |  ...  |  xn  ===>  e
     *                         top()     top()
     */
    if (yychar>=0) {
	pushed(n-1) = top();
	pushed(n)   = e;
    }
    else
	pushed(n-1) = e;
    sp -= (n-1);
    return e;
}

static Void local syntaxError(s)       /* report on syntax error           */
String s; {
    ERRMSG(row) "Syntax error in %s (unexpected %s)", s, unexpected()
    EEND;
}

static String local unexpected() {      /* find name for unexpected token  */
    static char buffer[100];
    static char *fmt = "%s \"%s\"";
    static char *kwd = "keyword";

    switch (yychar) {
	case 0         : return "end of input";

#define keyword(kw) sprintf(buffer,fmt,kwd,kw); return buffer;
	case INFIXL    : keyword("infixl");
	case INFIXR    : keyword("infixr");
	case INFIX     : keyword("infix");
	case TINSTANCE : keyword("instance");
	case TCLASS    : keyword("class");
	case PRIMITIVE : keyword("primitive");
	case CASEXP    : keyword("case");
	case OF        : keyword("of");
	case IF        : keyword("if");
	case TRUNST    : keyword("runST");
	case THEN      : keyword("then");
	case ELSE      : keyword("else");
	case WHERE     : keyword("where");
	case TYPE      : keyword("type");
	case DATA      : keyword("data");
	case TNEWTYPE  : keyword("newtype");
	case LET       : keyword("let");
	case IN        : keyword("in");
	case DERIVING  : keyword("deriving");
	case DEFAULT   : keyword("default");
	case IMPORT    : keyword("import");
	case MODULE    : keyword("module");
#undef keyword

	case ARROW     : return "`->'";
	case '='       : return "`='";
	case COCO      : return "`::'";
	case '-'       : return "`-'";
	case '!'       : return "`!'";
	case ','       : return "comma";
	case '@'       : return "`@'";
	case '('       : return "`('";
	case ')'       : return "`)'";
	case '|'       : return "`|'";
	case ';'       : return "`;'";
	case UPTO      : return "`..'";
	case '['       : return "`['";
	case ']'       : return "`]'";
	case '_'       : return "`_'";
	case FROM      : return "`<-'";
	case '\\'      : return "backslash (lambda)";
	case '~'       : return "tilde";
	case '`'       : return "backquote";
#if TREX
	case RECSELID  : sprintf(buffer,"selector \"#%s\"",
				 textToStr(extText(snd(yylval))));
			 return buffer;
#endif
	case VAROP     :
	case VARID     :
	case CONOP     :
	case CONID     : sprintf(buffer,"symbol \"%s\"",
				 textToStr(textOf(yylval)));
			 return buffer;
	case HIDING    : return "symbol \"hiding\"";
	case QUALIFIED : return "symbol \"qualified\"";
	case ASMOD     : return "symbol \"as\"";
	case NUMLIT    : return "numeric literal";
	case CHARLIT   : return "character literal";
	case STRINGLIT : return "string literal";
	case IMPLIES   : return "`=>'";
	default        : return "token";
    }
}

static Cell local checkPrec(p)         /* Check for valid precedence value */
Cell p; {
    if (!isInt(p) || intOf(p)<MIN_PREC || intOf(p)>MAX_PREC) {
	ERRMSG(row) "Precedence value must be an integer in the range [%d..%d]",
		    MIN_PREC, MAX_PREC
	EEND;
    }
    return p;
}

static Void local fixDefn(a,line,p,ops)/* Declare syntax of operators      */
Syntax a;
Cell   line;
Cell   p;
List   ops; {
    Int l = intOf(line);
    a     = mkSyntax(a,intOf(p));
    map2Proc(setSyntax,l,a,ops);
}

static Void local setSyntax(line,sy,op)/* set syntax of individ. operator  */
Int    line;
Syntax sy;
Cell   op; {
    addSyntax(line,textOf(op),sy);
    opDefns = cons(op,opDefns);
}

static Cell local buildTuple(tup)      /* build tuple (x1,...,xn) from list*/
List tup; {                            /* [xn,...,x1]                      */
    Int  n = 0;
    Cell t = tup;
    Cell x;

    do {                               /*     .                    .       */
	x      = fst(t);               /*    / \                  / \      */
	fst(t) = snd(t);               /*   xn  .                .   xn    */
	snd(t) = x;                    /*        .    ===>      .          */
	x      = t;                    /*         .            .           */
	t      = fun(x);               /*          .          .            */
	n++;                           /*         / \        / \           */
    } while (nonNull(t));              /*        x1  NIL   (n)  x1         */
    fst(x) = mkTuple(n);
    return tup;
}

static List local checkContext(con)     /* validate type class context     */
Type con; {
    mapOver(checkClass,con);
    return con;
}

static Cell local checkClass(c)         /* check that type expr is a class */
Cell c; {                               /* constrnt of the form Class var  */
    Cell cn = getHead(c);

#if TREX
    if (isExt(cn) && argCount==1)
	return c;
#endif
    if (!isCon(cn))
	syntaxError("class expression");
    else if (argCount!=1) {
	ERRMSG(row) "Class \"%s\" must have exactly one argument",
		    textToStr(textOf(cn))
	EEND;
    }
    else if (whatIs(arg(c))!=VARIDCELL) {
	ERRMSG(row) "Argument of class \"%s\" must be a variable",
		    /* Ha!  What do you think this is?  Gofer!? :-) */
		    textToStr(textOf(cn))
	EEND;
    }
    return c;
}

static Cell local checkInst(c)          /* check that type expr is a class */
Cell c; {                               /* constr of the form Class simple */
    Cell cn = getHead(c);

    if (!isCon(cn))
	syntaxError("class expression");
    else if (argCount!=1) {
	ERRMSG(row) "Class \"%s\" must have exactly one argument",
		    textToStr(textOf(cn))
	EEND;
    }
    else {
	Cell a  = arg(c);
	Cell tn = getHead(a);
#if TREX
	if (isCon(tn) || isTycon(tn) || isTuple(tn) || isExt(tn)) {
#else
	if (isCon(tn) || isTycon(tn) || isTuple(tn)) {
#endif
	    for (; isAp(a); a=fun(a))
		if (whatIs(arg(a))!=VARIDCELL) {
		    ERRMSG(row) "Type variable expected in instance type"
		    EEND;
		}
	}
	else {
	    ERRMSG(row) "Illegal type expression in instance declaration"
	    EEND;
	}
    }
    return c;
}

static Pair local checkDo(dqs)          /* convert reversed list of dquals */
List dqs; {                             /* to an (expr,quals) pair         */
    if (isNull(dqs) || whatIs(hd(dqs))!=DOQUAL) {
	ERRMSG(row) "Last generator in do {...} must be an expression"
	EEND;
    }
    fst(dqs) = snd(fst(dqs));           /* put expression in fst of pair   */
    snd(dqs) = rev(snd(dqs));           /* & reversed list of quals in snd */
    return dqs;
}

static Cell local checkTyLhs(c)         /* check that lhs is of the form   */
Cell c; {                               /* T a1 ... a                      */
    Cell tlhs = c;
    while (isAp(tlhs) && whatIs(arg(tlhs))==VARIDCELL)
	tlhs = fun(tlhs);
    if (whatIs(tlhs)!=CONIDCELL) {
	ERRMSG(row) "Illegal left hand side in type definition"
	EEND;
    }
    return c;
}

/* Expressions involving infix operators or unary minus are parsed as elements
 * of the following type:
 *
 *     data OpExp = Only Exp | Neg OpExp | Infix OpExp Op Exp
 *
 * (The algorithms here do not assume that negation can be applied only once,
 * i.e., that - - x is a syntax error, as required by the Haskell report.
 * Instead, that restriction is captured by the grammar itself, given above.)
 *
 * There are rules of precedence and grouping, expressed by two functions:
 *
 *     prec :: Op -> Int;   assoc :: Op -> Assoc    (Assoc = {L, N, R})
 *
 * OpExp values are rearranged accordingly when a complete expression has
 * been read using a simple shift-reduce parser whose result may be taken
 * to be a value of the following type:
 *
 *     data Exp = Atom Int | Negate Exp | Apply Op Exp Exp | Error String
 *
 * The machine on which this parser is based can be defined as follows:
 *
 *     tidy                         :: OpExp -> [(Op,Exp)] -> Exp
 *     tidy (Only a)      []         = a
 *     tidy (Only a)      ((o,b):ss) = tidy (Only (Apply o a b)) ss
 *     tidy (Infix a o b) []         = tidy a [(o,b)]
 *     tidy (Infix a o b) ((p,c):ss)
 *                      | shift  o p = tidy a ((o,b):(p,c):ss)
 *                      | red    o p = tidy (Infix a o (Apply p b c)) ss
 *                      | ambig  o p = Error "ambiguous use of operators"
 *     tidy (Neg e)       []         = tidy (tidyNeg e) []
 *     tidy (Neg e)       ((o,b):ss)
 *                      | nshift o   = tidy (Neg (underNeg o b e)) ss
 *                      | nred   o   = tidy (tidyNeg e) ((o,b):ss)
 *                      | nambig o   = Error "illegal use of negation"
 *
 * At each stage, the parser can either shift, reduce, accept, or error.
 * The transitions when dealing with juxtaposed operators o and p are
 * determined by the following rules:
 *
 *     shift o p  = (prec o > prec p)
 *               || (prec o == prec p && assoc o == L && assoc p == L)
 *
 *     red o p    = (prec o < prec p)
 *               || (prec o == prec p && assoc o == R && assoc p == R)
 *
 *     ambig o p  = (prec o == prec p)
 *               && (assoc o == N || assoc p == N || assoc o /= assoc p)
 *
 * The transitions when dealing with juxtaposed unary minus and infix operators
 * are as follows.  The precedence of unary minus (infixl 6) is hardwired in
 * to these definitions, as it is to the definitions of the Haskell grammar
 * in the official report.
 *
 *     nshift o   = (prec o > 6)
 *     nred   o   = (prec o < 6) || (prec o == 6 && assoc o == L)
 *     nambig o   = prec o == 6 && (assoc o == R || assoc o == N)
 *
 * An OpExp of the form (Neg e) means negate the last thing in the OpExp e;
 * we can force this negation using:
 *
 *     tidyNeg              :: OpExp -> OpExp
 *     tidyNeg (Only e)      = Only (Negate e)
 *     tidyNeg (Infix a o b) = Infix a o (Negate b)
 *     tidyNeg (Neg e)       = tidyNeg (tidyNeg e)
 * 
 * On the other hand, if we want to sneak application of an infix operator
 * under a negation, then we use:
 *
 *     underNeg                  :: Op -> Exp -> OpExp -> OpExp
 *     underNeg o b (Only e)      = Only (Apply o e b)
 *     underNeg o b (Neg e)       = Neg (underNeg o b e)
 *     underNeg o b (Infix e p f) = Infix e p (Apply o f b)
 *
 * As a concession to efficiency, we lower the number of calls to syntaxOf
 * by keeping track of the values of sye, sys throughout the process.  The
 * value APPLIC is used to indicate that the syntax value is unknown.
 */

static Cell local tidyInfix(e)		/* convert OpExp to Expr	   */
Cell e; {				/* :: OpExp			   */
    Cell s     = NIL;			/* :: [(Op,Exp)]		   */
    Syntax sye = APPLIC;		/* Syntax of op in e (init unknown)*/
    Syntax sys = APPLIC;		/* Syntax of op in s (init unknown)*/

    for (;;) {
	switch (whatIs(e)) {
	    case ONLY : e = snd(e);
                        while (nonNull(s)) {
                            Cell next   = arg(fun(s));
                            arg(fun(s)) = e;
                            e           = s;
                            s           = next;
			}
		        return e;

	    case NEG  : if (nonNull(s)) {

			    if (sys==APPLIC) {	/* calculate sys	   */
				sys = syntaxOf(textOf(fun(fun(s))));
				if (sys==APPLIC) sys=DEF_OPSYNTAX;
			    }

			    if (precOf(sys)==UMINUS_PREC &&	/* nambig  */
				assocOf(sys)!=UMINUS_ASSOC) {
				ERRMSG(row)
				 "Ambiguous use of unary minus with \"%s\"",
				 textToStr(textOf(fun(fun(s))))
				EEND;
			    }

			    if (precOf(sys)>UMINUS_PREC) {	/* nshift  */
				Cell e1    = snd(e);
				Cell t     = s;
                                s          = arg(fun(s));
				while (whatIs(e1)==NEG)
				    e1 = snd(e1);
				arg(fun(t)) = arg(e1);
                                arg(e1)     = t;
				sys         = APPLIC;
				continue;
			    }
			
			}

			/* Intentional fall-thru for nreduce and isNull(s) */

			{   Cell prev = e;		/* e := tidyNeg e  */
			    Cell temp = arg(prev);
			    Int  nneg = 1;
			    for (; whatIs(temp)==NEG; nneg++) {
				fun(prev) = nameNegate;
				prev	  = temp;
				temp	  = arg(prev);
			    }
			    if (isInt(arg(temp))) {	/* special cases   */
				if (nneg&1)		/* for literals    */
				    arg(temp) = mkInt(-intOf(arg(temp)));
			    }
#if BIGNUMS
			    else if (isBignum(arg(temp))) {
				if (nneg&1)
				    arg(temp) = bigNeg(arg(temp));
			    }
#endif
			    else if (isFloat(arg(temp))) {
				if (nneg&1)
				    arg(temp) = mkFloat(-floatOf(arg(temp)));
			    }
			    else {
				fun(prev) = nameNegate;
				arg(prev) = arg(temp);
				arg(temp) = e;
			    }
			    e = temp;
			}
			continue;

	    default   : if (isNull(s)) {/* Move operation onto empty stack */
			    Cell next   = arg(fun(e));
			    s           = e;
			    arg(fun(s)) = NIL;
                            e           = next;
			    sys         = sye;
			    sye         = APPLIC;
			}
                        else {		/* deal with pair of operators	   */

			    if (sye==APPLIC) {	/* calculate sys and sye   */
				sye = syntaxOf(textOf(fun(fun(e))));
				if (sye==APPLIC) sye=DEF_OPSYNTAX;
			    }
			    if (sys==APPLIC) {
				sys = syntaxOf(textOf(fun(fun(s))));
				if (sys==APPLIC) sys=DEF_OPSYNTAX;
			    }

			    if (precOf(sye)==precOf(sys) &&	/* ambig   */
				(assocOf(sye)!=assocOf(sys) ||
				 assocOf(sye)==NON_ASS)) {
				ERRMSG(row)
				"Ambiguous use of operator \"%s\" with \"%s\"",
			    	 textToStr(textOf(fun(fun(e)))),
			    	 textToStr(textOf(fun(fun(s))))
				EEND;
			    }

			    if (precOf(sye)>precOf(sys) ||	/* shift   */
				(precOf(sye)==precOf(sys) &&
				 assocOf(sye)==LEFT_ASS &&
				 assocOf(sys)==LEFT_ASS)) {
				Cell next   = arg(fun(e));
				arg(fun(e)) = s;
				s           = e;
				e	    = next;
				sys         = sye;
				sye         = APPLIC;
			    }
			    else {				/* reduce */
				Cell next   = arg(fun(s));
				arg(fun(s)) = arg(e);
				arg(e)      = s;
				s	    = next;
				sys         = APPLIC;
				/* sye unchanged */
			    }
			}
			continue;
	}
    }
}

/*-------------------------------------------------------------------------*/
short yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
-1, 111,
	289, 207,
	44, 207,
	-2, 241,
-1, 123,
	293, 139,
	-2, 151,
-1, 199,
	293, 139,
	-2, 82,
-1, 211,
	293, 139,
	-2, 129,
-1, 214,
	293, 139,
	-2, 131,
-1, 228,
	293, 138,
	-2, 165,
-1, 239,
	289, 210,
	-2, 164,
-1, 339,
	293, 140,
	-2, 168,
-1, 341,
	293, 141,
	-2, 170,
-1, 358,
	289, 210,
	-2, 164,
-1, 397,
	123, 217,
	-2, 161,
	};
#define YYNPROD 309
# define YYLAST 1860
short yyact[]={

  33, 182, 513, 119, 485, 109, 500, 404, 389, 508,
 121, 390, 444, 506, 456, 333,  49, 367,  88,  23,
 302, 382, 288, 238, 101, 206, 113,  44, 304,  24,
 475, 445,  89,  43, 334,  90,  94, 196, 321, 299,
 128,  80, 124,  34,  41, 304, 195, 127, 126,  47,
  55,  31,  34, 319, 135,  34, 314,  35,  36,  37,
 136, 470, 309, 522, 158, 227,  35,  36,  37,  35,
  36,  37, 116,  20, 376, 117,  84, 115, 179, 374,
  30, 198,  43, 266,  22, 114, 217, 194, 524, 316,
 116, 354, 217, 117,  46, 115, 544, 527, 136, 406,
 463, 126, 469, 504, 202, 202, 317, 202, 202, 190,
 457, 116, 197, 111, 117,  21, 115, 458, 172, 455,
 141, 274,   8, 239, 246, 310,  52,  45, 193, 246,
   6, 331, 246, 272, 111, 364, 156, 146,  50, 147,
 157, 274, 251, 157, 260,   4,   2,   3, 183, 150,
 264,  82,  59, 531, 243, 275, 269, 445, 180, 224,
 468, 221, 110, 443, 284, 237,  95, 415, 256, 351,
  60,  96, 353, 283, 240, 169,  66, 263, 171, 208,
  69, 125, 186, 110, 247, 433, 255,  63, 434,  53,
 362, 178, 414, 248, 151, 223, 177, 307, 118, 442,
 246,  67, 202, 271, 246, 154, 449, 439, 265, 261,
 188, 187, 246, 185, 540, 246, 246, 127, 292, 523,
 325, 305, 293, 280, 224, 521, 324, 453, 246, 435,
 246, 413, 436, 380, 530, 131, 357, 318, 338, 132,
 320, 375, 358, 246, 237, 270,  66, 327, 358, 360,
 246,  34, 352, 359, 246,  66, 298, 168, 170, 111,
 361, 458, 111, 539, 520,  35,  36,  37, 253,  28,
 519,  34,  25,  26,  27, 160,  32,  29, 164, 184,
 207, 139,  34, 250, 303,  35,  36,  37, 496, 416,
  54, 326, 417, 240, 489, 452,  35,  36,  37, 240,
 336, 303, 412, 386, 233, 267,  34, 246, 110, 246,
 373, 110, 246, 158, 419, 123, 127, 388, 163, 408,
  35,  36,  37, 279, 181, 162, 387, 378, 395, 402,
 379, 532, 403, 405, 315, 111, 488, 216, 161, 385,
 483, 127, 409, 127, 157, 202,  32, 399, 246, 392,
 503, 246, 407, 246, 295, 246, 220, 246, 428, 230,
 296, 429, 418, 430, 306, 432,  34, 438, 111, 273,
 294, 126, 199, 203,  51, 211, 214, 431, 336,  54,
  35,  36,  37, 420, 110, 423, 368, 427, 345, 273,
 208, 229, 246, 246, 246, 246, 151, 381, 447, 358,
 307, 459, 202, 451, 202, 240, 246, 371, 307, 462,
 464, 246, 246, 454, 246, 369, 385, 110, 329, 473,
 450, 158, 246, 233, 476, 246,  34, 246, 130, 233,
 226, 245, 460, 480, 478, 246, 242, 246, 312, 487,
  35,  36,  37, 377, 420, 215, 423, 274, 300, 301,
 240,  42, 287, 155, 492, 336, 281, 490, 246, 272,
 158, 246, 246, 246, 383, 246, 246, 246, 491, 502,
 311, 246, 246, 246, 514, 498, 505, 395, 509, 516,
 518, 149, 495, 517, 289, 123, 293,   5, 497, 111,
 395, 336, 112, 486, 349, 405, 441, 350, 392,  61,
  62, 348, 189, 460, 175, 460, 246, 440, 246,  75,
 356, 392, 247, 366,  76,  86, 356, 529,  85, 528,
  77,  97, 422, 111, 425, 127, 535, 336, 538, 501,
 537, 533, 534, 246, 541,  17, 346, 514, 110, 347,
 148, 487, 515, 542, 246,  87, 460, 250, 460, 467,
 343, 365, 244, 344, 545,  34, 234, 244, 341,  24,
 474, 342, 368, 131,  48, 252,  57, 132, 494,  35,
  36,  37, 110, 176,   9, 222, 175, 393,  34, 219,
 233,  81, 145,  32, 123,  34, 481, 218, 410,  79,
 411, 144,  35,  36,  37, 486, 142, 501, 236,  35,
  36,  37, 191, 192, 167, 515, 235, 168, 231, 421,
  30, 424, 323, 426,  22, 250, 422, 120, 425, 322,
 510, 511,  72, 212, 258, 209, 259, 205, 244,  24,
  74, 262, 244,  83,  70, 526, 165, 525, 268, 166,
 244, 512, 394, 244, 499,  21, 488,  93, 484, 482,
 384, 276, 332, 277,  91, 278, 225,  40, 244,  39,
 461,  38, 285,  34, 286,   1, 291, 356, 337,   0,
 471,   0, 472,   0,   0, 335,   0,  35,  36,  37,
  30,  12, 244,   0,  22,  53,   0,   0,   0,   0,
   0,   0,  24,   0,   0, 273,   0,  11,  34,   0,
 469,   0,  34, 421,   0, 424, 328, 337,   0, 330,
 297,  92,  35,  36,  37,  21,  35,  36,  37,   0,
   0, 200, 204,   0, 210, 213, 393,   0, 129,   0,
   0, 461,   0, 461,   0,   0,   0,   0,   0, 393,
 244,   0,   0,  30,  12,  24,   0,  22,   0,   0,
  11, 370,   0,   0,  34,   0, 372,   0,   0, 126,
   0,   0,  19,   0,  92,   0,   0,   0,  35,  36,
  37,   0,   0,   0, 461,  58, 461,  24,  21,   0,
  64,  65,  11, 363,  68, 244,   0,   0,   0,   0,
 158, 479,   0, 123,   0,   0,  30,  12,   0,  28,
  22,  34,  25,  26,  27,   0,  32,  29,   0, 247,
 339,   0, 158, 340,   0,  35,  36,  37,   0,   0,
 140, 244, 244, 244,   0,   0,   0,   0,  30,  12,
 159,  21,  22,   0, 244,   0,   0,   0,   0, 244,
 244,   0, 173, 174,   0,   7,   0,   0,  15, 437,
 244,   0,  14, 244,   0, 244,  13,  24,   0, 446,
 131, 448,  11,  21, 132,  16,   0,   0,  18,  28,
  71,  34,  25,  26,  27,  73,  32,  29,   0,   0,
   0,   0,   0,   0,   0,  35,  36,  37,  34, 244,
 244,   0,   0,  32, 244, 244,   0,   0,   0, 477,
 244, 244,  35,  36,  37,  24,   0,   0,  30,  12,
  11,  15,  22, 103, 102,  14,   0,   0,   0,  13,
   0, 100,  98,  99, 105, 104, 108, 493,  16, 106,
 107,  18,  28,   0,  34,  25,  26,  27,   0,  32,
  29, 201,   0,  21,   0,   0,   0, 101,  35,  36,
  37,   0,   0,   0,   0,   0,  30,  12,   0,   0,
  22,   0,   0,   0,  15,   0, 103, 102,  14,   0,
   0,   0,  13,   0, 100,  98,  99, 105, 104, 108,
   0,  16, 106, 107,  18,  28,   0,  34,  25,  26,
  27,  21,  32,  29,   0,   0,  15,   0, 103, 102,
  14,  35,  36,  37,  13,   0,   0, 536,   0, 105,
 104, 108,   0,  16, 106, 107,  18,  28,   0,  34,
  25,  26,  27,   0,  32,  29,  24, 282,   0,   0,
   0, 138,  34,  35,  36,  37,   0, 337,  10,   0,
   0,   0,   0,   0, 335,   0,  35,  36,  37,   0,
  56,  34,   0,   0,  34,   0, 245,   0,   0, 337,
   0, 242,   0,  78,   0,  35,  36,  37,  35,  36,
  37,   0,   0,   7,   0,   0,  15,  30,  12,   0,
  14,  22,   0,   0,  13,   0, 134,  24,   0,   0,
   0,   0,  11,  16, 137,   0,  18,  28,   0,  34,
  25,  26,  27,   0,  32,  29, 143,   0,   0,  56,
   0,   0,  21,  35,  36,  37,   0,   0,   0,   0,
   0,   7,   0,   0,  15,   0,   0,   0,  14,  24,
   0,   0, 290,   0,  11,   0,   0,   0,  30,  12,
   0,  16,  22,   0,  18,  28,   0,  34,  25,  26,
  27,   0,  32,  29,   0,   0,   0,   0,   0,   0,
   0,  35,  36,  37,   0,  24,   0,   0,   0,   0,
  11,   0, 254,  21,   0,   0,   0, 257,   0,   0,
  30,  12,   0,  34,  22,   0,   0,   0, 126,   0,
   0,   0,  24, 161,   0,   0,   0,  35,  36,  37,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0, 137,   0,   0,   0,  21,  30,  12,   0,   0,
  22,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,  24,   0,   0,   0,   0, 138,
   0, 247,   0,  30,  12,  15,   0,  22,   0,  14,
   0,  21,   0,  13,   0,   0,   0,   0,   0,   0,
   0,   0,  16,   0,   0,  18,  28,   0,  34,  25,
  26,  27,   0,  32,  29,   0,   0,   0,  21,   0,
   0,   0,  35,  36,  37,  30,  12,   0,   0,  22,
   0,   0, 131,   0,   0,  24, 132, 463,   0,   0,
 133,   0,   0,   0,   0,   0,  15,   0,   0,   0,
  14,   0, 241, 355,  13,   0,  83,   0,   0,   0,
  21,   0,   0,  16,   0,   0,  18,  28,   0,  34,
  25,  26,  27,   0,  32,  29,   0,   0,  24,   0,
   0,   0,   0,  35,  36,  37,  30,  12,  15,   0,
  22, 247,  14,   0,   0,   0,  13,   0,   0,   0,
   0,   0,   0, 131,   0,  16,   0, 132,  18,  28,
   0,  34,  25,  26,  27,   0,  32,  29,   0,   0,
   0,  21,   0,   0,  15,  35,  36,  37, 153,  30,
  12, 247, 152,  22,   0,   0,   0,   0,   0,   0,
   0,  16, 131,   0,  18,  28, 132,  34,  25,  26,
  27,  15,  32,  29,   0,  14, 241, 355,   0,  13,
  83,  35,  36,  37,  21,   0,   0,   0,  16, 241,
 228,  18,  28,  83,  34,  25,  26,  27,   0,  32,
  29,   0, 131,   0, 274,   0, 132, 465,  35,  36,
  37, 241, 355,  15, 247,  83,   0,  14,   0,   0,
   0,  13,   0,   0,   0, 543,   0, 131, 391,   0,
  16, 132, 247,  18,  28, 398,  34,  25,  26,  27,
 131,  32,  29,  34, 132,   0,   0,  54, 245,   0,
  35,  36,  37,   0, 247,   0,   0,  35,  36,  37,
   0,   0, 131,   0,   0, 131, 132,   0,   0, 132,
 463, 247, 400,   0,  15, 401,   0,   0,  14,   0,
   0,   0,  13, 131, 122,   0, 131, 132, 129, 507,
 132,  16,   0,   0,  18,  28, 247,  34,  25,  26,
  27, 466,  32,  29,   0, 131,   0,   0, 247, 132,
   0,  35,  36,  37,  34, 247,   0,  15, 469, 126,
   0,  14, 131,   0, 232,  13, 132, 129,  35,  36,
  37,   0, 247,   0,  16, 131, 313,  18,  28, 132,
  34,  25,  26,  27, 247,  32,  29, 131,   0,   0,
   0, 132,   0,  34,  35,  36,  37,   0, 126, 131,
   0, 247,   0, 132,   0, 308, 131,  35,  36,  37,
 132,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0, 131,   0,   0,   0, 132,   0,   0,
   0,   0, 129,  34,   0, 131,   0,   0, 245, 132,
   0,   0,   0, 242,   0, 129,   0,  35,  36,  37,
   0,   0, 131,   0,   0,   0, 132,   0,  34,   0,
   0,   0,   0, 126,   0,   0,   0, 129, 232,   0,
   0,  34,  35,  36,  37,   0, 126,   0,   0,   0,
   0, 232,   0,   0,   0,  35,  36,  37, 129,   0,
   0, 396, 273,  34,   0,   0,  34,   0, 126,   0,
  54, 245,   0, 232,   0,   0,   0,  35,  36,  37,
  35,  36,  37,   0,  34,   0,   0,  34,   0, 126,
   0,   0, 397,   0,   0,   0,   0,   0,  35,  36,
  37,  35,  36,  37,   0,   0,  34,   0,   0,   0,
 129, 245,   0,   0,   0,   0, 249,   0,   0,   0,
  35,  36,  37,  34,   0,   0,   0,   0, 245,   0,
   0,   0,   0,   0,   0,   0,  34,  35,  36,  37,
   0, 126,   0,   0,   0,   0,   0,   0,  34,   0,
  35,  36,  37, 126,   0,   0,   0,   0,   0,   0,
  34,   0,  35,  36,  37, 245,   0,  34,   0,   0,
   0,   0, 245,   0,  35,  36,  37,   0,   0,   0,
   0,  35,  36,  37,  34,   0,   0,   0,   0, 126,
   0,   0,   0,   0,   0,   0,  34,   0,  35,  36,
  37, 245,   0,   0,   0,   0,   0,   0,   0,   0,
  35,  36,  37,  34,   0,   0,   0,   0, 245,   0,
   0,   0,   0,   0,   0,   0,   0,  35,  36,  37 };
short yypact[]={

-111,-1000, 817,-212,-1000,-139,-1000,-1000,-195,  93,
  93,1298, 519,  47, 817, 817,  64, 519, 519,  53,
 137, 519,-1000,  57, 589,-1000,-1000,-1000,-1000,-1000,
 817,-1000,-1000,-1000,-1000,-1000,-1000,-1000,-1000, 652,
-261,-1000,-1000,-171,-1000,  47,1484,1255,-1000,-1000,
-1000,-1000,-1000,-227,-1000,1194,-1000, -11,  53,-148,
1047,-127,-121,1125,  53,  53, 273, 519,  53, 273,
1152, 284, 277, 237,-1000, 595, 563, 134,  93, 519,
 519, 532,-1000,-1000, 135,  98,  34, 213,  23,-1000,
 154, 152,-1000, 151,-1000,-1000,-1000,-1000,-174,-174,
-174,-210,-175, 901, 901,  24, 901, 901, 405,  48,
 100, 137,-1000, 390,-1000,-1000,-1000,-1000,-1000,-1000,
-228,-1000,1389,1351,-1000,-1000,-1000, 101,1454,-1000,
-1000, 472,-1000,1298,-1000,  90,  72,-1000,1298, 817,
  53, 817,  23,-1000, 150,-1000, 817,  54,  23, 149,
-1000,-208,  47, 817,  31, 201,-1000, 142,  88,  53,
  30,-1000,-1000,-1000,-1000,-1000, 817,-1000, 817,-1000,
 817, 416, 986, 132, 123,-1000,-1000, 817,-1000, 817,
 865, 817,-1000,-1000,-1000, 705,-1000,-271, 737,  93,
-1000,  93,  93, -12,-192,-1000, 303,-1000,-1000,1544,
-231,  84, 101,1515,-237,  45,-1000,-1000,-179,-139,
-240,1561,-139,-255,1561,1311,1484, 273,-1000,-139,
-1000, 817,  35,-1000, 817,-135, 381,1311,-1000, 769,
 517, 509, 347, 495, 460, 453, 128,-1000,-1000, 101,
-198,1411,1311,-1000,-1000,-1000,-1000,1376,-230,1311,
-1000,  97,-1000,1351,-1000,-1000,-1000,-1000,-1000,-1000,
-1000,1089,-130,1089,-1000,1125, 817,-148,-127,-1000,
 273, 817, 297, 284, 277,-1000,-1000,-1000, 269,-1000,
 135, 108,-1000,-1000,-1000,-1000,-211, 197,-1000,-217,
  47,-1000,-1000,-1000, 705,-1000,-1000,-1000, 189,-1000,
 189, 189,-1000, 357, 420,   5,1311,-1000,1435,-175,
-1000,1471, 288,  59,-175,1484, 273,-1000,-1000,-186,
-1000,-186, 261, 187,-1000,-1000,-1000,-1000,-1000,-1000,
 131,  44, 248,-1000,-1000,-192,-1000, 274,-1000,-1000,
1311,-1000,1311,-1000,-239,-1000,-1000,1311,-1000,-1000,
1311,-1000,1311, 416,1311,-1000, 144, 188,-1000,-1000,
-1000,-1000,-1000,-1000, 817,  23, 148,-1000, -93,-1000,
-1000,-1000,-1000,-1000, 817, 865, 817,-148,-1000, 147,
  93, 420, 254,-1000, 183,-1000,-192,-1000,-149, -14,
-1000,1532,1201,1414,1508,  37,-1000,-1000,1272,   0,
-1000,-239,-1000,-239,-158,1561,-184, -31,-1000,-1000,
1561,1561,-1000,1311, 817, 652,-1000, 750,-1000, 296,
-1000,1351,-1000,-1000,1351,-1000,1561,-1000,-1000,-1000,
 253,-1000,-1000,-1000,1311,-1000,1311,-1000,-1000,1089,
-139,  33, 817,-1000,-1000,1089,-1000,-1000,-1000, 705,
-1000, 247,-1000, 772, -12, 273,-1000,1435,  63,   4,
1561,1561,1496,-189,1496,1561,1561,-1000, 273, 237,
1435,1561,1561,-1000,-1000,  59,-1000,-1000,  23,-1000,
-1000, 229, 223,-1000, 181,-1000,-1000,-1000, 414,-1000,
-1000,-1000,-1000,-1000,-229,-1000,-1000,-1000,-1000, 175,
-1000,-201,-1000,-1000,-190,1496,-1000,1532,-1000,-1000,
-1000,-1000, 109,-1000,  42,-1000, -14,-158,-1000,-1000,
-1000, 606, 817, 273,1484, 222, 170,-1000,-1000,-1000,
-1000, 273,1432,-1000,-1000,-1000,-1000,-1000,-1000,-1000,
-191,-1000,-1000,1311,-1000,-1000 };
short yypgo[]={

   0, 665, 484,  27, 661, 659,  18,   1, 657, 451,
  26, 656,  32,  35, 654, 182, 652,  15,  34, 166,
  20,  21, 650,  73, 649, 648,   4,  19,  36, 502,
 256,  39, 564,  16,   0, 647, 171, 521,  37,  10,
 644, 268,   8,  14, 617,   7,   6,   3,  11,   9,
  13,  40, 642, 641, 154,   2,   5, 637, 635, 627,
  25, 625, 623, 619, 612, 236,  42, 608, 181, 428,
 556, 606, 598,  23,  51, 152, 596, 591, 122, 587,
 579, 575, 195, 130, 574,1038, 566, 551, 540, 535,
 762, 205, 514, 520, 518, 151, 513,  17, 507, 496,
  12, 481, 149, 453, 136, 452,  22 };
short yyr1[]={

   0,   1,   1,   1,   4,   4,   8,   8,   9,   9,
  10,  10,  10,   6,   6,   6,   6,   6,  11,  11,
  11,  16,  16,  17,  17,  14,  14,  15,  19,  19,
  19,  19,  20,  20,  20,  21,  21,  21,  21,  22,
  22,  18,  18,  18,  18,  24,  24,  24,  24,  25,
  25,  26,  26,  13,  13,  28,  28,  28,  29,  29,
  30,  30,  31,  31,  31,  32,  32,  32,  33,  33,
  12,  12,  12,  12,  35,  35,  35,  35,  36,  36,
  36,  36,  36,  36,  36,  36,  38,  38,  38,  40,
  40,  46,  46,  42,  42,  48,  48,  48,  48,  48,
  48,  48,  52,  52,  52,  50,  50,  53,  53,  55,
  55,  45,  43,  43,  43,  57,  57,  58,  58,  36,
  59,  59,  59,  60,  60,  36,  36,  36,  61,  61,
  62,  62,  63,  63,  64,  64,  47,  47,  44,  44,
  44,  44,  44,  44,  66,  67,  67,  67,  67,  67,
  39,  39,  68,  68,  68,  68,  49,  49,  51,  51,
  41,  41,  54,  54,  69,  69,  69,  69,  69,  69,
  69,  69,  69,  69,  69,  69,  69,  70,  70,  65,
  65,  71,  71,  71,  71,  72,  72,  73,  75,  76,
  76,  76,  76,  77,  77,  37,  37,  79,  79,  80,
  80,   3,   3,  81,  81,  82,  56,  56,  23,  23,
  74,  74,  74,  34,  34,  34,  34,  27,  27,   2,
   2,  83,  83,  78,  78,  84,  84,  84,  84,  84,
  85,  85,  85,  85,  85,  85,  86,  86,  89,  89,
  89,  90,  90,  90,  90,  90,  90,  90,  90,  90,
  90,  90,  90,  90,  90,  90,  90,  90,  90,  90,
  90,  90,  90,  92,  92,  93,  93,  95,  87,  87,
  96,  96,  97,  98,  98,  98,  99,  99, 100,  88,
  88, 101, 101, 102, 102, 102, 102,  91,  91, 103,
 103, 104, 104,  94,  94,  94,  94,  94,  94,  94,
  94, 105, 105, 106, 106, 106,   5,   7,   7 };
short yyr2[]={

   0,   3,   2,   1,   3,   1,   2,   1,   7,   2,
   1,   1,   1,   1,   3,   2,   4,   6,   0,   3,
   4,   3,   1,   1,   2,   3,   1,   0,   3,   6,
   4,   2,   0,   4,   3,   0,   1,   1,   2,   3,
   1,   1,   1,   4,   4,   0,   1,   1,   2,   3,
   1,   1,   1,   3,   1,   3,   3,   3,   1,   0,
   3,   1,   1,   1,   1,   1,   1,   3,   1,   3,
   0,   1,   1,   2,   3,   3,   1,   1,   4,   6,
   5,   7,   2,   4,   5,   7,   2,   1,   1,   3,
   1,   3,   1,   3,   1,   4,   3,   3,   1,   1,
   4,   1,   3,   3,   2,   2,   1,   3,   1,   3,
   4,   2,   0,   2,   4,   0,   1,   3,   1,   4,
   3,   1,   1,   2,   1,   3,   3,   4,   3,   1,
   3,   1,   0,   1,   3,   1,   3,   1,   2,   1,
   3,   3,   1,   3,   3,   3,   3,   3,   3,   1,
   1,   1,   1,   3,   3,   1,   1,   1,   2,   1,
   2,   1,   1,   1,   1,   2,   3,   3,   3,   3,
   3,   3,   3,   5,   3,   2,   1,   2,   1,   3,
   3,   3,   3,   3,   3,   3,   1,   3,   3,   0,
   1,   1,   2,   3,   1,   3,   2,   2,   1,   2,
   1,   2,   0,   2,   1,   4,   3,   1,   1,   3,
   1,   3,   3,   1,   1,   1,   1,   1,   3,   1,
   1,   3,   1,   1,   1,   4,   3,   2,   3,   4,
   4,   4,   6,   6,   4,   1,   2,   1,   2,   2,
   1,   1,   3,   2,   1,   1,   4,   4,   2,   1,
   1,   1,   1,   3,   3,   3,   5,   1,   3,   4,
   4,   4,   3,   3,   3,   3,   1,   3,   1,   2,
   3,   1,   3,   1,   2,   1,   2,   1,   4,   2,
   1,   3,   1,   3,   2,   2,   1,   0,   1,   3,
   1,   1,   3,   0,   1,   1,   3,   3,   4,   2,
   5,   3,   1,   3,   1,   2,   1,   1,   1 };
short yychk[]={

-1000,  -1, 257, 258, 256,  -2, -83, 256, -78, -84,
 -85,  45,  92, 267, 263, 259, 276, -89, 279, -90,
 -23, 126,  95, -27,  40, 283, 284, 285, 280, 288,
  91, -74, 287, -34, 282, 296, 297, 298,  -4,  -5,
  -8, 256,  -9, 294,  -3, 266, 289, -31, -32, -33,
  45, 281,  33,  96, 286, -31, -85, -86, -90, -75,
 123,  -2,  -2, 123, -90, -90, 123,  64, -90, 123,
  45, 281,  33, 286,  41,  -2, -92, -93, -85, -32,
 -33, -70, -95,  44, -74, -94,  -2, -92,  -6, -12,
 -13, -14,  59, -35, -28, -19, -36, -37, 270, 271,
 269, 295, 262, 261, 273, 272, 277, 278, 274, -56,
 -78, -23,  -9, -10, 256, 287, 282, 285, -75, -47,
 -44, -39,  40, -41, -66, -68, 287, -34, -51, 256,
 -69,  91,  95,  45, -85, -34, 287, -85,  45, 292,
 -90, 268, -76,  59, -77, -37, 264, 260, -88,-101,
-102, -83, 267, 263, -91,-103,-104, -23,  40, -90,
 -91,  41,  41,  41,  41,  41,  44,  41,  44,  41,
 124,  44, -31, -90, -90,  44,  41,  61,  93,  44,
 124, 290,  -7, 125, 256,  59, -15,  59,  59, -29,
 283, -29, -29, -10, 297, 256, -38, 287, 256, -41,
 -44,  40, -34, -41, -44, -59, -60, 256, -23, -61,
 -44, -41, -62, -44, -41,  40, 289,  44, -79, -80,
 256,  61, -81, -82, 124, -11,  40, 293,  41, -41,
 -65, -67, 292, -68, -70, -71, -72, -66, -73, -34,
 -74,  40, 292, -54, -69, 287, -34,  40,  92, 292,
 -54, -39,  93, -41, -85,  96,  96, -85,  -2,  -2,
  -7,  59,  -2, 123,  -7,  59, 291, -75,  -2, 125,
  44,  61,  45, 281,  33, 125,  -2,  -2,  -2, -95,
 -74,  40,  41,  41,  41,  -2,  -2,-105,-106,  -2,
 267,  -2, -12, -28, -15, -19, -36, -37, -30, -31,
 -30, -30, -20, 296,  40, -10,  61, -34,  61, 293,
  41, -41, -65,  61, 293, 289,  44, 285,  -3, 293,
  -3, 293, -63, -64, -39, -47, -23,  -3,  -2, -82,
  -2, 266, -16, -17, -18, 294, -23, 287, -39,  41,
  44,  41,  44,  41,  44,  41,  41,  44,  41,  41,
  44,  41, 124,  44, 289,  41, -41, -65, -34, -39,
 -34, -39,  93, -37, 265, -87, -96, -97, -78,-102,
  -2,-104,  -2,  41, 290,  44, 291, -75, -12, -13,
  44,  40, -21,  44, -22, -18, 298, -20, -39, -42,
 -48,  33, -51, -41, -52, -27, 256, 287,  40, -38,
  41,  44,  41,  44, -45, -27,  40, -38, -47, -60,
 -41, -41,  41,  44,  61, 123,  41,  44, -10,  40,
 -66, -41, -68, -66, -41, -68, -41, -66, -39, -39,
 -39, -73, -39,  41,  44,  41,  44,  -2,  -7,  59,
 -98, -99, 292, 256,-100, 124,  -2,-106,  -2,  59,
 -31, -21,  41,  44, -10, 268, -43, 124, 275, -49,
 -51, -41, -33,  96, -33,  33,  33, -54, 123, 286,
  61, -41, -41, -43, -54,  61, -39,  -2,  -6,  41,
 -17, 290, -24,  44, -25, -26, -23, -27,  40,  41,
 -97,  -3,-100,  -2, -78, -12,  41, -18, -20, -40,
 -46, -23, -48, 287,  40, -33, -50,  33, -49, -50,
 -54, -54, -53, -55, -56, -23, -42, -45,  -7,  41,
  41,  44, 292,  44, 289, -57, -58, 287, -50, -49,
 125,  44, 289, -43, -43, -26,  -2, -46, -47,  41,
  44, -55, -39,  33, 287, -39 };
short yydef[]={

   0,  -2,   0,   0,   3, 202, 219, 220, 222, 223,
 224,   0,   0,   0,   0,   0,   0, 235,   0, 240,
 241,   0, 244, 245,   0, 249, 250, 251, 252, 257,
 293, 208, 217, 210, 213, 214, 215, 216,   2,  70,
   5, 306,   7,   0,   1,   0,   0,   0,  62,  63,
  64,  65,  66,   0,  68,   0, 227,   0, 237,   0,
 189,   0,   0,   0, 238, 239, 287,   0, 243, 287,
   0,  65,  66,  68, 248,   0,   0,   0, 224,   0,
   0,   0, 266, 178, 208,   0, 294, 295,   0,  13,
   0,  27,  71,  72,  54,  26,  76,  77,  59,  59,
  59,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,  -2,   6,  18,   9,  10,  11,  12, 201, 221,
   0, 137,   0,  -2, 142, 150, 161, 164, 152, 155,
 159,   0, 176,   0, 226,   0,   0, 228,   0,   0,
 236,   0,   0, 190, 191, 194,   0,   0,   0, 280,
 282, 286,   0,   0,   0, 288, 290, 291,   0, 242,
   0, 209, 211, 212, 218, 253,   0, 254,   0, 255,
   0,   0,   0,   0,   0, 177, 262,   0, 258,   0,
   0, 299,   4, 307, 308,  70,  15,  27,  73,   0,
  58,   0,   0,  32,   0,  31,   0,  87,  88,  -2,
   0,   0,   0, 139,   0,   0, 121, 122, 124, 202,
   0,  -2, 202,   0,  -2, 132,   0,   0, 196, 202,
 198,   0, 200, 204,   0,   0,   0,   0,  -2,   0,
   0,   0,   0,   0,   0,   0,   0, 149, 186,  -2,
   0,   0,   0, 160, 162, 163, 164,   0,   0,   0,
 158,   0, 175, 151, 225,  67,  69, 229, 230, 231,
 188, 192,   0,   0, 234, 279,   0, 284, 285, 247,
   0,   0,   0,   0,   0, 246, 264, 263,   0, 265,
   0,   0, 259, 260, 261, 267, 264, 296, 302, 304,
   0, 297,  14,  53,  70,  25,  74,  75,  55,  61,
  56,  57,  28,   0,  35,  32,   0,  86,   0,   0,
 138,   0,   0,   0,   0,   0,   0, 123, 125,   0,
 126,   0,   0, 133, 135, 195, 206, 197, 199, 203,
   0,   0,   0,  22,  23,   0,  41,  42, 136,  -2,
   0,  -2,   0, 143,   0, 166, 167,   0, 169, 171,
   0, 172,   0,   0,   0, 165,   0,   0,  -2, 154,
 144, 153, 174, 193,   0,   0, 268, 271,   0, 281,
 283, 289, 292, 256, 298,   0,   0, 305,  16,   0,
   0,  35,   0,  36,  37,  40,   0,  30,  78, 112,
  94,   0,   0,  98,  99,   0, 101,  -2,   0,  83,
 140,   0, 141,   0, 112,   0,   0,   0, 119, 120,
 128, 130, 127,   0,   0,  70,  19,   0,  24,  45,
 148, 180, 182, 145, 179, 183, 146, 147, 181, 184,
   0, 185, 187, 168,   0, 170,   0, 232, 233, 269,
 202, 273,   0, 275, 277,   0, 300, 301, 303,  70,
  60,   0,  34,  38,  32,   0,  80,   0,   0,   0,
 156, 157,   0,   0,   0,   0,   0, 104,   0,   0,
   0, 180, 179,  84, 111,   0, 134, 205,   0,  20,
  21,   0,   0,  46,  47,  50,  51,  52,   0, 173,
 270, 272, 276, 274,   0,  17,  33,  39,  29,  79,
  90,  92,  93, 113, 115,   0,  96,   0, 106,  97,
 102, 103,   0, 108,   0, 207, 112, 112,   8,  43,
  44,  48,   0,   0,   0,   0, 116, 118,  95, 105,
 100,   0,   0,  81,  85,  49, 278,  89,  91, 114,
   0, 107, 109,   0, 117, 110 };
#define YYFLAG   -1000
#define YYERROR  goto yyerrlab
#define YYACCEPT return(0)
#define YYABORT  return(1)

/*      parser for yacc output  */

#ifdef YYDEBUG
int yydebug     = 0;     /* 1 for debugging */
#endif
YYSTYPE yyv[YYMAXDEPTH]; /* where the values are stored */
int yychar      = -1;    /* current input token number */
int yynerrs     = 0;     /* number of errors */
short yyerrflag = 0;     /* error recovery flag */

int yyparse() {
    short yys[YYMAXDEPTH];
    short yyj, yym;
    register YYSTYPE *yypvt;
    register short yystate, *yyps, yyn;
    register YYSTYPE *yypv;
    register short *yyxi;

    yystate   = 0;
    yychar    = -1;
    yynerrs   = 0;
    yyerrflag = 0;
    yyps      = &yys[-1];
    yypv      = &yyv[-1];

yystack:    /* put a state and value onto the stack */

#ifdef YYDEBUG
    if (yydebug)
        printf("state %d, char 0%o\n", yystate, yychar);
#endif
    if(++yyps>&yys[YYMAXDEPTH]) {
        yyerror("yacc stack overflow");
        return(1);
    }
    *yyps = yystate;
    ++yypv;
#ifdef UNION
    yyunion(yypv, &yyval);
#else
    *yypv = yyval;
#endif

yynewstate:

    yyn = yypact[yystate];

    if (yyn<=YYFLAG)
        goto yydefault; /* simple state */

    if (yychar<0)
        if ((yychar=yylex())<0)
            yychar=0;
    if ((yyn+=yychar)<0 || yyn>=YYLAST)
        goto yydefault;

    if (yychk[yyn=yyact[yyn]]==yychar) {
        /* valid shift */
        yychar = -1;
#ifdef UNION
        yyunion(&yyval, &yylval);
#else
        yyval = yylval;
#endif
        yystate = yyn;
        if (yyerrflag>0)
            --yyerrflag;
        goto yystack;

    }

yydefault:

    /* default state action */

    if ((yyn=yydef[yystate])== -2) {
        if (yychar<0)
            if ((yychar=yylex())<0)
                yychar = 0;
        /* look through exception table */

        for (yyxi=yyexca; (*yyxi!= (-1)) || (yyxi[1]!=yystate) ; yyxi += 2)
            ; /* VOID */

        for (yyxi+=2; *yyxi >= 0; yyxi+=2) {
            if (*yyxi==yychar)
                break;
        }
        if ((yyn=yyxi[1])<0)
            return(0);   /* accept */
    }

    if (yyn==0) {
        /* error */
        /* error ... attempt to resume parsing */

        switch (yyerrflag) {
            case 0: /* brand new error */
                    yyerror( "syntax error" );

yyerrlab:           ++yynerrs;

            case 1:
            case 2: /* incompletely recovered error ... try again */

                    yyerrflag = 3;

                    /* find a state where "error" is a legal shift action */

                    while (yyps>=yys) {
                        yyn = yypact[*yyps] + YYERRCODE;
                        if (yyn>=0 && yyn<YYLAST
                                   && yychk[yyact[yyn]]==YYERRCODE) {
                            yystate = yyact[yyn];
                            /* simulate a shift of "error" */
                            goto yystack;
                        }
                        yyn = yypact[*yyps];

                        /* the current yyps has no shift on "error",
                           pop stack */

#ifdef YYDEBUG
                        if (yydebug)
                            printf("error recovery pops state %d, uncovers %d\n", *yyps, yyps[-1]);
#endif

                        --yyps;
                        --yypv;
                    }

                    /* there is no state on the stack with an error shift
                       ... abort */

yyabort:            return(1);


            case 3: /* no shift yet; clobber input char */
#ifdef YYDEBUG
                    if (yydebug)
                        printf("error recovery discards char %d\n", yychar);
#endif

                    if (yychar==0)
                        goto yyabort; /* don't discard EOF, quit */
                    yychar = -1;
                    goto yynewstate;   /* try again in the same state */
        }
    }

    /* reduction by production yyn */

#ifdef YYDEBUG
    if (yydebug)
        printf("reduce %d\n",yyn);
#endif
    yyps -= yyr2[yyn];
    yypvt = yypv;
    yypv -= yyr2[yyn];
#ifdef UNION
    yyunion(&yyval, &yypv[1]);
#else
    yyval = yypv[1];
#endif
    yym=yyn;
    /* consult goto table to find next state */
    yyn = yyr1[yyn];
    yyj = yypgo[yyn] + *yyps + 1;
    if (yyj>=YYLAST || yychk[yystate=yyact[yyj]]!= -yyn)
        yystate = yyact[yypgo[yyn]];
    switch(yym) {
        
case 1:
# line 86
{inputExpr = letrec(yypvt[-0],yypvt[-1]); sp-=2;} break;
case 2:
# line 87
{valDefns  = yypvt[-0];            sp-=1;} break;
case 3:
# line 88
{syntaxError("input");} break;
case 4:
# line 97
{yyval = gc2(yypvt[-1]);} break;
case 5:
# line 98
{yyval = yypvt[-0];} break;
case 6:
# line 100
{yyval = gc2(appendOnto(yypvt[-0],yypvt[-1]));} break;
case 7:
# line 101
{yyval = yypvt[-0];} break;
case 8:
# line 104
{yyval = gc7(yypvt[-1]);} break;
case 9:
# line 105
{syntaxError("module definition");} break;
case 10:
# line 107
{yyval = yypvt[-0];} break;
case 11:
# line 108
{yyval = yypvt[-0];} break;
case 12:
# line 109
{yyval = yypvt[-0];} break;
case 13:
# line 111
{yyval = yypvt[-0];} break;
case 14:
# line 112
{yyval = gc3(yypvt[-0]);} break;
case 15:
# line 113
{yyval = gc2(NIL);} break;
case 16:
# line 114
{yyval = gc4(yypvt[-0]);} break;
case 17:
# line 116
{yyval = gc6(yypvt[-0]);} break;
case 18:
# line 121
{yyval = gc0(NIL);} break;
case 19:
# line 122
{yyval = gc3(NIL);} break;
case 20:
# line 123
{yyval = gc4(NIL);} break;
case 21:
# line 125
{yyval = gc3(NIL);} break;
case 22:
# line 126
{yyval = yypvt[-0];} break;
case 23:
# line 128
{yyval = yypvt[-0];} break;
case 24:
# line 129
{yyval = gc2(NIL);} break;
case 25:
# line 134
{imps = cons(yypvt[-0],imps); yyval=gc3(NIL);} break;
case 26:
# line 135
{imps = singleton(yypvt[-0]); yyval=gc1(NIL);} break;
case 27:
# line 137
{if (chase(imps)) {
					     clearStack();
					     onto(imps);
                                             done();
					     closeAnyInput();
					     return 0;
					 }
					 yyval = gc0(NIL);
					} break;
case 28:
# line 147
{yyval = gc3(yypvt[-1]);} break;
case 29:
# line 149
{yyval = gc6(yypvt[-3]);} break;
case 30:
# line 151
{yyval = gc4(yypvt[-1]);} break;
case 31:
# line 152
{syntaxError("import declaration");} break;
case 32:
# line 154
{yyval = gc0(NIL);} break;
case 33:
# line 155
{yyval = gc4(NIL);} break;
case 34:
# line 156
{yyval = gc3(NIL);} break;
case 35:
# line 158
{yyval = gc0(NIL);} break;
case 36:
# line 159
{yyval = gc1(NIL);} break;
case 37:
# line 160
{yyval = yypvt[-0];} break;
case 38:
# line 161
{yyval = gc2(yypvt[-1]);} break;
case 39:
# line 163
{yyval = gc3(NIL);} break;
case 40:
# line 164
{yyval = yypvt[-0];} break;
case 41:
# line 166
{yyval = yypvt[-0];} break;
case 42:
# line 167
{yyval = yypvt[-0];} break;
case 43:
# line 168
{yyval = gc4(NIL);} break;
case 44:
# line 169
{yyval = gc4(NIL);} break;
case 45:
# line 171
{yyval = gc0(NIL);} break;
case 46:
# line 172
{yyval = gc1(NIL);} break;
case 47:
# line 173
{yyval = yypvt[-0];} break;
case 48:
# line 174
{yyval = gc2(yypvt[-1]);} break;
case 49:
# line 176
{yyval = gc3(NIL);} break;
case 50:
# line 177
{yyval = gc1(NIL);} break;
case 51:
# line 179
{yyval = yypvt[-0];} break;
case 52:
# line 180
{yyval = yypvt[-0];} break;
case 53:
# line 185
{yyval = gc2(NIL);} break;
case 54:
# line 186
{yyval = gc0(NIL);} break;
case 55:
# line 188
{fixDefn(LEFT_ASS,yypvt[-2],yypvt[-1],yypvt[-0]); sp-=3;} break;
case 56:
# line 189
{fixDefn(RIGHT_ASS,yypvt[-2],yypvt[-1],yypvt[-0]);sp-=3;} break;
case 57:
# line 190
{fixDefn(NON_ASS,yypvt[-2],yypvt[-1],yypvt[-0]);  sp-=3;} break;
case 58:
# line 192
{yyval = gc1(checkPrec(yypvt[-0]));} break;
case 59:
# line 193
{yyval = gc0(mkInt(DEF_PREC));} break;
case 60:
# line 195
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 61:
# line 196
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 62:
# line 198
{yyval = yypvt[-0];} break;
case 63:
# line 199
{yyval = yypvt[-0];} break;
case 64:
# line 200
{yyval = gc1(varMinus);} break;
case 65:
# line 202
{yyval = yypvt[-0];} break;
case 66:
# line 203
{yyval = gc1(varBang);} break;
case 67:
# line 204
{yyval = gc3(yypvt[-1]);} break;
case 68:
# line 206
{yyval = yypvt[-0];} break;
case 69:
# line 207
{yyval = gc3(yypvt[-1]);} break;
case 70:
# line 212
{yyval = gc0(NIL);} break;
case 71:
# line 213
{yyval = gc1(NIL);} break;
case 72:
# line 214
{yyval = yypvt[-0];} break;
case 73:
# line 215
{yyval = gc2(yypvt[-1]);} break;
case 74:
# line 217
{yyval = gc2(yypvt[-2]);} break;
case 75:
# line 218
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 76:
# line 219
{yyval = gc0(NIL);} break;
case 77:
# line 220
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 78:
# line 225
{defTycon(4,yypvt[-1],yypvt[-2],yypvt[-0],SYNONYM);} break;
case 79:
# line 227
{defTycon(6,yypvt[-3],yypvt[-4],
						    ap(yypvt[-2],yypvt[-0]),RESTRICTSYN);} break;
case 80:
# line 230
{defTycon(5,yypvt[-2],checkTyLhs(yypvt[-3]),
						    ap(rev(yypvt[-1]),yypvt[-0]),DATATYPE);} break;
case 81:
# line 233
{defTycon(7,yypvt[-2],yypvt[-3],
						  ap(ap(QUAL,pair(yypvt[-5],rev(yypvt[-1]))),
						     yypvt[-0]),DATATYPE);} break;
case 82:
# line 236
{defTycon(2,yypvt[-1],checkTyLhs(yypvt[-0]),
						    ap(NIL,NIL),DATATYPE);} break;
case 83:
# line 238
{defTycon(4,yypvt[-3],yypvt[-0],
						  ap(ap(QUAL,pair(yypvt[-2],NIL)),
						     NIL),DATATYPE);} break;
case 84:
# line 242
{defTycon(5,yypvt[-2],checkTyLhs(yypvt[-3]),
						    ap(yypvt[-1],yypvt[-0]),NEWTYPE);} break;
case 85:
# line 245
{defTycon(7,yypvt[-2],yypvt[-3],
						  ap(ap(QUAL,pair(yypvt[-5],yypvt[-1])),
						     yypvt[-0]),NEWTYPE);} break;
case 86:
# line 249
{yyval = gc2(ap(yypvt[-1],yypvt[-0]));} break;
case 87:
# line 250
{yyval = yypvt[-0];} break;
case 88:
# line 251
{syntaxError("type defn lhs");} break;
case 89:
# line 253
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 90:
# line 254
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 91:
# line 256
{yyval = gc3(sigdecl(yypvt[-1],singleton(yypvt[-2]),
							     yypvt[-0]));} break;
case 92:
# line 258
{yyval = yypvt[-0];} break;
case 93:
# line 260
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 94:
# line 261
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 95:
# line 263
{yyval = gc4(ap(ap(yypvt[-1],bang(yypvt[-2])),yypvt[-0]));} break;
case 96:
# line 264
{yyval = gc3(ap(ap(yypvt[-1],yypvt[-2]),yypvt[-0]));} break;
case 97:
# line 265
{yyval = gc3(ap(ap(yypvt[-1],yypvt[-2]),yypvt[-0]));} break;
case 98:
# line 266
{yyval = yypvt[-0];} break;
case 99:
# line 267
{yyval = yypvt[-0];} break;
case 100:
# line 268
{yyval = gc4(ap(LABC,pair(yypvt[-3],rev(yypvt[-1]))));} break;
case 101:
# line 269
{syntaxError("data type definition");} break;
case 102:
# line 271
{yyval = gc3(ap(yypvt[-2],bang(yypvt[-0])));} break;
case 103:
# line 272
{yyval = gc3(ap(yypvt[-2],bang(yypvt[-0])));} break;
case 104:
# line 273
{yyval = gc2(ap(yypvt[-1],yypvt[-0]));} break;
case 105:
# line 275
{yyval = gc2(bang(yypvt[-0]));} break;
case 106:
# line 276
{yyval = yypvt[-0];} break;
case 107:
# line 278
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 108:
# line 279
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 109:
# line 281
{yyval = gc3(pair(rev(yypvt[-2]),yypvt[-0]));} break;
case 110:
# line 282
{yyval = gc4(pair(rev(yypvt[-3]),bang(yypvt[-0])));} break;
case 111:
# line 284
{yyval = gc2(singleton(ap(yypvt[-1],yypvt[-0])));} break;
case 112:
# line 286
{yyval = gc0(NIL);} break;
case 113:
# line 287
{yyval = gc2(singleton(yypvt[-0]));} break;
case 114:
# line 288
{yyval = gc4(yypvt[-1]);} break;
case 115:
# line 290
{yyval = gc0(NIL);} break;
case 116:
# line 291
{yyval = gc1(rev(yypvt[-0]));} break;
case 117:
# line 293
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 118:
# line 294
{yyval = gc1(singleton(yypvt[-0]));} break;
case 119:
# line 299
{primDefn(yypvt[-3],yypvt[-2],yypvt[-0]); sp-=4;} break;
case 120:
# line 301
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 121:
# line 302
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 122:
# line 303
{syntaxError("primitive defn");} break;
case 123:
# line 305
{yyval = gc2(pair(yypvt[-1],yypvt[-0]));} break;
case 124:
# line 306
{yyval = yypvt[-0];} break;
case 125:
# line 311
{classDefn(intOf(yypvt[-2]),yypvt[-1],yypvt[-0]); sp-=3;} break;
case 126:
# line 312
{instDefn(intOf(yypvt[-2]),yypvt[-1],yypvt[-0]);  sp-=3;} break;
case 127:
# line 313
{defaultDefn(intOf(yypvt[-3]),yypvt[-1]);  sp-=4;} break;
case 128:
# line 315
{yyval = gc3(pair(yypvt[-2],checkClass(yypvt[-0])));} break;
case 129:
# line 316
{yyval = gc1(pair(NIL,checkClass(yypvt[-0])));} break;
case 130:
# line 318
{yyval = gc3(pair(yypvt[-2],checkInst(yypvt[-0])));} break;
case 131:
# line 319
{yyval = gc1(pair(NIL,checkInst(yypvt[-0])));} break;
case 132:
# line 321
{yyval = gc0(NIL);} break;
case 133:
# line 322
{yyval = gc1(rev(yypvt[-0]));} break;
case 134:
# line 324
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 135:
# line 325
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 136:
# line 330
{yyval = gc3(ap(QUAL,pair(yypvt[-2],yypvt[-0])));} break;
case 137:
# line 331
{yyval = yypvt[-0];} break;
case 138:
# line 333
{yyval = gc2(NIL);} break;
case 139:
# line 334
{yyval = gc1(singleton(checkClass(yypvt[-0])));} break;
case 140:
# line 335
{yyval = gc3(singleton(checkClass(yypvt[-1])));} break;
case 141:
# line 336
{yyval = gc3(checkContext(yypvt[-1]));} break;
case 142:
# line 338
{yyval = gc1(singleton(yypvt[-0]));} break;
case 143:
# line 339
{yyval = gc3(checkContext(yypvt[-1]));} break;
case 144:
# line 341
{yyval = gc3(ap(mkExt(textOf(yypvt[-0])),yypvt[-2]));} break;
case 145:
# line 343
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 146:
# line 344
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 147:
# line 345
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 148:
# line 346
{yyval = gc3(cons(yypvt[-0],cons(yypvt[-2],NIL)));} break;
case 149:
# line 347
{yyval = gc1(singleton(yypvt[-0]));} break;
case 150:
# line 350
{yyval = yypvt[-0];} break;
case 151:
# line 351
{yyval = yypvt[-0];} break;
case 152:
# line 353
{yyval = yypvt[-0];} break;
case 153:
# line 354
{yyval = gc3(ap(ap(typeArrow,yypvt[-2]),yypvt[-0]));} break;
case 154:
# line 355
{yyval = gc3(ap(ap(typeArrow,yypvt[-2]),yypvt[-0]));} break;
case 155:
# line 356
{syntaxError("type expression");} break;
case 156:
# line 358
{yyval = yypvt[-0];} break;
case 157:
# line 359
{yyval = yypvt[-0];} break;
case 158:
# line 361
{yyval = gc2(ap(yypvt[-1],yypvt[-0]));} break;
case 159:
# line 362
{yyval = yypvt[-0];} break;
case 160:
# line 364
{yyval = gc2(ap(yypvt[-1],yypvt[-0]));} break;
case 161:
# line 365
{yyval = yypvt[-0];} break;
case 162:
# line 367
{yyval = yypvt[-0];} break;
case 163:
# line 368
{yyval = yypvt[-0];} break;
case 164:
# line 370
{yyval = yypvt[-0];} break;
case 165:
# line 371
{yyval = gc2(typeUnit);} break;
case 166:
# line 372
{yyval = gc3(typeArrow);} break;
case 167:
# line 373
{yyval = gc3(yypvt[-1]);} break;
case 168:
# line 374
{yyval = gc3(yypvt[-1]);} break;
case 169:
# line 375
{yyval = gc3(yypvt[-1]);} break;
case 170:
# line 376
{yyval = gc3(buildTuple(yypvt[-1]));} break;
case 171:
# line 377
{yyval = gc3(buildTuple(yypvt[-1]));} break;
case 172:
# line 379
{yyval = gc3(revOnto(yypvt[-1],typeNoRow));} break;
case 173:
# line 380
{yyval = gc5(revOnto(yypvt[-3],yypvt[-1]));} break;
case 174:
# line 382
{yyval = gc3(ap(typeList,yypvt[-1]));} break;
case 175:
# line 383
{yyval = gc2(typeList);} break;
case 176:
# line 384
{yyval = gc1(inventVar());} break;
case 177:
# line 386
{yyval = gc2(mkTuple(tupleOf(yypvt[-1])+1));} break;
case 178:
# line 387
{yyval = gc1(mkTuple(2));} break;
case 179:
# line 389
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 180:
# line 390
{yyval = gc3(cons(yypvt[-0],cons(yypvt[-2],NIL)));} break;
case 181:
# line 392
{yyval = gc3(cons(yypvt[-0],cons(yypvt[-2],NIL)));} break;
case 182:
# line 393
{yyval = gc3(cons(yypvt[-0],cons(yypvt[-2],NIL)));} break;
case 183:
# line 394
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 184:
# line 395
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 185:
# line 398
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 186:
# line 399
{yyval = gc1(singleton(yypvt[-0]));} break;
case 187:
# line 401
{yyval = gc3(ap(mkExt(textOf(yypvt[-2])),yypvt[-0]));} break;
case 188:
# line 407
{yyval = gc3(yypvt[-1]);} break;
case 189:
# line 409
{yyval = gc0(NIL);} break;
case 190:
# line 410
{yyval = gc1(NIL);} break;
case 191:
# line 411
{yyval = yypvt[-0];} break;
case 192:
# line 412
{yyval = gc2(yypvt[-1]);} break;
case 193:
# line 414
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 194:
# line 415
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 195:
# line 417
{yyval = gc3(sigdecl(yypvt[-1],yypvt[-2],yypvt[-0]));} break;
case 196:
# line 418
{yyval = gc2(pair(yypvt[-1],yypvt[-0]));} break;
case 197:
# line 420
{yyval = gc2(letrec(yypvt[-0],yypvt[-1]));} break;
case 198:
# line 421
{syntaxError("declaration");} break;
case 199:
# line 423
{yyval = gc2(pair(yypvt[-1],yypvt[-0]));} break;
case 200:
# line 424
{yyval = gc1(grded(rev(yypvt[-0])));} break;
case 201:
# line 426
{yyval = gc2(yypvt[-0]);} break;
case 202:
# line 427
{yyval = gc0(NIL);} break;
case 203:
# line 429
{yyval = gc2(cons(yypvt[-0],yypvt[-1]));} break;
case 204:
# line 430
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 205:
# line 432
{yyval = gc4(pair(yypvt[-1],pair(yypvt[-2],yypvt[-0])));} break;
case 206:
# line 434
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 207:
# line 435
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 208:
# line 437
{yyval = yypvt[-0];} break;
case 209:
# line 438
{yyval = gc3(varMinus);} break;
case 210:
# line 440
{yyval = yypvt[-0];} break;
case 211:
# line 441
{yyval = gc3(yypvt[-1]);} break;
case 212:
# line 442
{yyval = gc3(varBang);} break;
case 213:
# line 444
{yyval = yypvt[-0];} break;
case 214:
# line 445
{yyval = gc1(varHiding);} break;
case 215:
# line 446
{yyval = gc1(varQualified);} break;
case 216:
# line 447
{yyval = gc1(varAsMod);} break;
case 217:
# line 449
{yyval = yypvt[-0];} break;
case 218:
# line 450
{yyval = gc3(yypvt[-1]);} break;
case 219:
# line 455
{yyval = yypvt[-0];} break;
case 220:
# line 456
{syntaxError("expression");} break;
case 221:
# line 458
{yyval = gc3(ap(ESIGN,pair(yypvt[-2],yypvt[-0])));} break;
case 222:
# line 459
{yyval = yypvt[-0];} break;
case 223:
# line 461
{yyval = gc1(tidyInfix(yypvt[-0]));} break;
case 224:
# line 462
{yyval = yypvt[-0];} break;
case 225:
# line 464
{yyval = gc4(ap(NEG,ap(ap(yypvt[-2],yypvt[-3]),yypvt[-0])));} break;
case 226:
# line 465
{yyval = gc3(ap(ap(yypvt[-1],yypvt[-2]),yypvt[-0]));} break;
case 227:
# line 466
{yyval = gc2(ap(NEG,only(yypvt[-0])));} break;
case 228:
# line 467
{yyval = gc3(ap(ap(yypvt[-1],only(yypvt[-2])),yypvt[-0]));} break;
case 229:
# line 468
{yyval = gc4(ap(NEG,
						     ap(ap(yypvt[-2],only(yypvt[-3])),yypvt[-0])));} break;
case 230:
# line 471
{yyval = gc4(ap(LAMBDA,
						     pair(rev(yypvt[-2]),
							  pair(yypvt[-1],yypvt[-0]))));} break;
case 231:
# line 474
{yyval = gc4(letrec(yypvt[-2],yypvt[-0]));} break;
case 232:
# line 475
{yyval = gc6(ap(COND,triple(yypvt[-4],yypvt[-2],yypvt[-0])));} break;
case 233:
# line 476
{yyval = gc6(ap(CASE,pair(yypvt[-4],rev(yypvt[-1]))));} break;
case 234:
# line 477
{yyval = gc4(ap(DOCOMP,checkDo(yypvt[-1])));} break;
case 235:
# line 478
{yyval = yypvt[-0];} break;
case 236:
# line 480
{yyval = gc2(cons(yypvt[-0],yypvt[-1]));} break;
case 237:
# line 481
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 238:
# line 483
{yyval = gc2(ap(yypvt[-1],yypvt[-0]));} break;
case 239:
# line 484
{yyval = gc2(ap(RUNST,yypvt[-0]));} break;
case 240:
# line 485
{yyval = yypvt[-0];} break;
case 241:
# line 487
{yyval = yypvt[-0];} break;
case 242:
# line 488
{yyval = gc3(ap(ASPAT,pair(yypvt[-2],yypvt[-0])));} break;
case 243:
# line 489
{yyval = gc2(ap(LAZYPAT,yypvt[-0]));} break;
case 244:
# line 490
{yyval = gc1(WILDCARD);} break;
case 245:
# line 491
{yyval = yypvt[-0];} break;
case 246:
# line 492
{yyval = gc4(ap(CONFLDS,pair(yypvt[-3],yypvt[-1])));} break;
case 247:
# line 493
{yyval = gc4(ap(UPDFLDS,
						     triple(yypvt[-3],NIL,yypvt[-1])));} break;
case 248:
# line 495
{yyval = gc2(nameUnit);} break;
case 249:
# line 496
{yyval = yypvt[-0];} break;
case 250:
# line 497
{yyval = yypvt[-0];} break;
case 251:
# line 498
{yyval = yypvt[-0];} break;
case 252:
# line 499
{yyval = yypvt[-0];} break;
case 253:
# line 500
{yyval = gc3(yypvt[-1]);} break;
case 254:
# line 501
{yyval = gc3(buildTuple(yypvt[-1]));} break;
case 255:
# line 503
{yyval = gc3(revOnto(yypvt[-1],nameNoRec));} break;
case 256:
# line 504
{yyval = gc5(revOnto(yypvt[-3],yypvt[-1]));} break;
case 257:
# line 505
{yyval = yypvt[-0];} break;
case 258:
# line 507
{yyval = gc3(yypvt[-1]);} break;
case 259:
# line 508
{yyval = gc4(ap(yypvt[-1],yypvt[-2]));} break;
case 260:
# line 509
{yyval = gc4(ap(ap(nameFlip,yypvt[-2]),yypvt[-1]));} break;
case 261:
# line 510
{yyval = gc4(ap(ap(nameFlip,yypvt[-2]),yypvt[-1]));} break;
case 262:
# line 511
{yyval = gc3(yypvt[-1]);} break;
case 263:
# line 513
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 264:
# line 514
{yyval = gc3(cons(yypvt[-0],cons(yypvt[-2],NIL)));} break;
case 265:
# line 517
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 266:
# line 518
{yyval = gc1(singleton(yypvt[-0]));} break;
case 267:
# line 520
{yyval = gc3(ap(mkExt(textOf(yypvt[-2])),yypvt[-0]));} break;
case 268:
# line 523
{yyval = yypvt[-0];} break;
case 269:
# line 524
{yyval = gc2(yypvt[-1]);} break;
case 270:
# line 526
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 271:
# line 527
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 272:
# line 529
{yyval = gc3(pair(yypvt[-2],letrec(yypvt[-0],yypvt[-1])));} break;
case 273:
# line 531
{yyval = gc1(grded(rev(yypvt[-0])));} break;
case 274:
# line 532
{yyval = gc2(pair(yypvt[-1],yypvt[-0]));} break;
case 275:
# line 533
{syntaxError("case expression");} break;
case 276:
# line 535
{yyval = gc2(cons(yypvt[-0],yypvt[-1]));} break;
case 277:
# line 536
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 278:
# line 538
{yyval = gc4(pair(yypvt[-1],pair(yypvt[-2],yypvt[-0])));} break;
case 279:
# line 540
{yyval = gc2(yypvt[-1]);} break;
case 280:
# line 541
{yyval = yypvt[-0];} break;
case 281:
# line 543
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 282:
# line 544
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 283:
# line 546
{yyval = gc3(ap(FROMQUAL,pair(yypvt[-2],yypvt[-0])));} break;
case 284:
# line 547
{yyval = gc2(ap(QWHERE,yypvt[-0]));} break;
case 285:
# line 548
{yyval = gc2(ap(BOOLQUAL,yypvt[-0]));} break;
case 286:
# line 549
{yyval = gc1(ap(DOQUAL,yypvt[-0]));} break;
case 287:
# line 551
{yyval = gc0(NIL);} break;
case 288:
# line 552
{yyval = gc1(rev(yypvt[-0]));} break;
case 289:
# line 554
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 290:
# line 555
{yyval = gc1(singleton(yypvt[-0]));} break;
case 291:
# line 557
{yyval = yypvt[-0];} break;
case 292:
# line 558
{yyval = gc3(pair(yypvt[-2],yypvt[-0]));} break;
case 293:
# line 563
{yyval = gc0(nameNil);} break;
case 294:
# line 564
{yyval = gc1(ap(FINLIST,cons(yypvt[-0],NIL)));} break;
case 295:
# line 565
{yyval = gc1(ap(FINLIST,rev(yypvt[-0])));} break;
case 296:
# line 566
{yyval = gc3(ap(COMP,pair(yypvt[-2],rev(yypvt[-0]))));} break;
case 297:
# line 567
{yyval = gc3(ap(ap(nameFromTo,yypvt[-2]),yypvt[-0]));} break;
case 298:
# line 568
{yyval = gc4(ap(ap(nameFromThen,yypvt[-3]),yypvt[-1]));} break;
case 299:
# line 569
{yyval = gc2(ap(nameFrom,yypvt[-1]));} break;
case 300:
# line 570
{yyval = gc5(ap(ap(ap(nameFromThenTo,
							       yypvt[-4]),yypvt[-2]),yypvt[-0]));} break;
case 301:
# line 573
{yyval = gc3(cons(yypvt[-0],yypvt[-2]));} break;
case 302:
# line 574
{yyval = gc1(cons(yypvt[-0],NIL));} break;
case 303:
# line 576
{yyval = gc3(ap(FROMQUAL,pair(yypvt[-2],yypvt[-0])));} break;
case 304:
# line 577
{yyval = gc1(ap(BOOLQUAL,yypvt[-0]));} break;
case 305:
# line 578
{yyval = gc2(ap(QWHERE,yypvt[-0]));} break;
case 306:
# line 583
{yyerrok; goOffside(startColumn);} break;
case 307:
# line 586
{yyval = yypvt[-0];} break;
case 308:
# line 587
{yyerrok;
					 if (canUnOffside()) {
					     unOffside();
					     /* insert extra token on stack*/
					     push(NIL);
					     pushed(0) = pushed(1);
					     pushed(1) = mkInt(column);
					 }
					 else
					     syntaxError("definition");
					} break;/* End of actions */
    }
    goto yystack;  /* stack new state and value */

}
